﻿/*
SCROLLINGTEXT class created by Fabio Bernardi
www.faber04.com
faber04.blogspot.com

*/

package
{

	import flash.display.MovieClip;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.events.MouseEvent;
	import flash.events.Event;
	
	public class ScrollingText extends MovieClip
	{
		private var mybuttonUp:TextButtonUp=new TextButtonUp();
		private var mybuttonDown:TextButtonDown=new TextButtonDown();
		public var testo:TextField=new TextField();
		public var testoFormat:TextFormat=new TextFormat();
		public var testoBordo:Boolean=new Boolean();
		private var sali:Boolean=new Boolean();
		private var scendi:Boolean=new Boolean();
		public var testoLarghezza:Number=new Number();
		public var testoAltezza:Number=new Number();
		public var testoXpos:Number=new Number();
		public var testoYpos:Number=new Number();
		public var offset:Number=new Number();
		public var fla:MovieClip=new MovieClip();
		
		public function ScrollingText(_fla:MovieClip):void
		{
			fla=_fla;
			fla.addChild(testo);
			offset=10;
			mybuttonUp.stop();
			mybuttonDown.stop();
		}
		
		public function setTextField(xPos:Number, yPos:Number, l:Number, a:Number, border:Boolean):void
		{
			testo.x=xPos;
			testo.y=yPos;
			testo.width=l;
			testo.height=a;
			testo.border=border;
			testo.multiline=true;
			testo.wordWrap=true;
			buttonPositioning();
		}
		
		public function setFormatText(font:String, size:Number)
		{
			testoFormat.font=font;
			testoFormat.size=size;
			testo.setTextFormat(testoFormat);
		}
		
		public function insertContent(testoUtente:String, isHTML:Boolean):void
		{
			if(isHTML){
				testo.htmlText=testoUtente;
			}else{
				testo.text=testoUtente;
			}
			addEventListener(Event.ENTER_FRAME, checkScroll);
		}
		
		private function checkScroll(event:Event):void
		{
			if(sali){
				testo.scrollV-=1;
			}
			if(scendi){
				testo.scrollV+=1;
			}
			if(testo.maxScrollV<=1)
			{
				mybuttonDown.visible=false;
				mybuttonUp.visible=false;
			}
		}
		
		public function buttonPositioning():void
		{
			var pulsanti:Array=[mybuttonDown, mybuttonUp];
			fla.addChild(mybuttonDown);
			fla.addChild(mybuttonUp);
			with(mybuttonDown)
			{
				x=testo.x+testo.width+(mybuttonDown.width/2)+offset;
				y=testo.y+testo.height-(mybuttonDown.height/2);
			}
			with(mybuttonUp)
			{
				x=testo.x+testo.width+(mybuttonUp.width/2)+offset;
				y=testo.y+(mybuttonUp.height/2);
			}
			for(var i:Number=0; i<pulsanti.length; i++)
			{
				pulsanti[i].buttonMode=true;
				pulsanti[i].addEventListener(MouseEvent.ROLL_OUT, rollOutMe);
				pulsanti[i].addEventListener(MouseEvent.ROLL_OVER, rollOverMe);
				pulsanti[i].addEventListener(MouseEvent.MOUSE_DOWN, scrollText);
				pulsanti[i].addEventListener(MouseEvent.MOUSE_UP, stopScrollText);
			}
		}
		
		private function rollOverMe(event:MouseEvent)
		{
			event.currentTarget.gotoAndStop(2);
		}
		
		private function rollOutMe(event:MouseEvent)
		{
			event.currentTarget.gotoAndStop(1);
		}
		
		private function scrollText(event:MouseEvent)
		{
			switch(event.currentTarget){
				case mybuttonUp:
					sali=true;
				break;
				case mybuttonDown:
					scendi=true;
				break;
			}
		}
		
		private function stopScrollText(event:MouseEvent)
		{
			sali=false;
			scendi=false;
		}
		
	}
	
}